<?php
/*
Plugin Name: Quibcoding AddOn
Plugin URI: https://www.quibcoding.fr
Description: Ajoute champs (triable) longueur dans la table des posts
Version: 1.0
Author: Stéphane Audic / SARL Quibcoding
Author URI: http://www.quibcoding.fr
License: GPLv2 or later
*/

/* Plugin basé sur l'article de stackoverflow 
https://wordpress.stackexchange.com/questions/207043/find-empty-pages-or-pages-which-have-less-than-x-characters
*/

// Sécurité : on vérifie que WordPress est en train de charger le fichier
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Quitter si accédé directement
}

// Fonction d'activation
function quibcoding_addon_activation() {
    // Code à exécuter lors de l'activation du plugin
}
register_activation_hook( __FILE__, 'quibcoding_addon_activation' );

// Fonction de désactivation
function quibcoding_addon_deactivation() {
    // Code à exécuter lors de la désactivation du plugin
}
register_deactivation_hook( __FILE__, 'quibcoding_addon_deactivation' );

// Plugin operation
add_filter('manage_post_posts_columns', function ( $columns ) 
{
    $_columns = [];

    foreach( (array) $columns as $key => $label )
    {
        $_columns[$key] = $label; 
        if( 'title' === $key )
            $_columns['wpse_post_content_length'] = __( 'Length' );     
    }
    return $_columns;
} );
add_action( 'manage_post_posts_custom_column', function ( $column_name, $post_id ) 
{
    if ( $column_name == 'wpse_post_content_length')
        echo mb_strlen( get_post( $post_id )->post_content );

}, 10, 2 );

add_filter( 'manage_edit-post_sortable_columns', function ( $columns ) 
{
  $columns['wpse_post_content_length'] = 'wpse_post_content_length';
  return $columns;
} );

add_filter( 'posts_orderby', function( $orderby, \WP_Query $q )
{
    $_orderby = $q->get( 'orderby' );
    $_order   = $q->get( 'order' );

    if( 
           is_admin() 
        && $q->is_main_query() 
        && 'wpse_post_content_length' === $_orderby 
        && in_array( strtolower( $_order ), [ 'asc', 'desc' ] )
    ) {
        global $wpdb;
        $orderby = " LENGTH( {$wpdb->posts}.post_content ) " . $_order . " ";
    }
    return $orderby;
}, 10, 2 );


